=== debian/changelog ===
wasmedge (0.13.5+dfsg-1deepin0) unstable; urgency=medium

  * No source change upload against GCC 12.

 -- Tianyu Chen <sweetyfish@deepin.org>  Fri, 20 Sep 2024 12:57:42 +0800

wasmedge (0.13.5+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - Drop patch llama-cpp-gcc-13, was an upstream backport.
    - Add new symbols to libwasmedge0.symbols.
    - Update debian/copyright to reflect a source tree move.
  * Drop zlib1g-dev build dependency, as this was for LLD, which has now
    gained the build dependency itself. (cf. #1047718)
  * Mark the embed-cxx autopkgtest as flaky, as clang++-16 is currently buggy
    and cannot compile code for the wasm32-wasi target. (cf. #1052002)

 -- Faidon Liambotis <paravoid@debian.org>  Fri, 10 Nov 2023 16:37:25 +0200
