=== plugins/CMakeLists.txt ===
--- 
+++ 
@@ -54,6 +54,10 @@
   endif()
 endif()
 
+if(WASMEDGE_PLUGIN_WASI_OCR)
+  add_subdirectory(wasi_ocr)
+endif()
+
 if(WASMEDGE_PLUGIN_OPENCVMINI)
   # Only Linux and MacOS support wasmedge_opencvmini now.
   if(CMAKE_SYSTEM_NAME MATCHES "Linux|Darwin")
@@ -74,3 +78,7 @@
 if(WASMEDGE_PLUGIN_ZLIB)
   add_subdirectory(wasmedge_zlib)
 endif()
+
+if(WASMEDGE_PLUGIN_FFMPEG)
+  add_subdirectory(wasmedge_ffmpeg)
+endif()
