=== debian/changelog ===
wasmedge (0.14.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - Add patch Restore-CXX_VISIBILITY_PRESET-hidden, to fix a regression in
      which hundreds of internal C++ symbols are inadvertently exposed.
    - Add new symbols to libwasmedge0.symbols, and drop the
      WasmEdge::Plugin::PluginRegister:* and "WasmEdge_ValueGenNullRef"
      symbols without an ABI bump (not used by any reverse deps).
    - Add a patch to port the parse_json example (used by autopkgtests)
      to the new WasmEdge_ValType API.
  * Properly fix the GCC 14 FTBFS (maybe-uninitialized) through a backport of
    an upstream patch. Thanks to Reinhard Tartler and Diederik de Haas for
    engaging with upstream on this matter.
  * Bump Standards-Version to 4.7.0, no changes needed.

 -- Faidon Liambotis <paravoid@debian.org>  Thu, 15 Aug 2024 14:15:56 +0300

wasmedge (0.13.5+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with gcc-14, Closes: #1075633

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 03 Aug 2024 11:02:05 -0400
